/* Copyright 2020-2022, Michele Santullo
 * This file is part of wrenpp.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with wrenpp.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <cstddef>

namespace wren {
	class Configuration {
	public:
		Configuration();
		~Configuration() noexcept = default;

		std::size_t initial_heap_size() const { return m_initial_heap_size; }
		void set_initial_heap_size(std::size_t v) { m_initial_heap_size = v; }

		std::size_t min_heap_size() const { return m_min_heap_size; }
		void set_min_heap_size(std::size_t v) { m_min_heap_size = v; }

		std::size_t heap_growth_percent() const { return m_heap_growth_percent; }
		void set_heap_growth_percent(std::size_t v) { m_heap_growth_percent = v; }

	private:
		std::size_t m_initial_heap_size;
		std::size_t m_min_heap_size;
		std::size_t m_heap_growth_percent;
	};
} //namespace wren
