/* Copyright 2020-2022, Michele Santullo
 * This file is part of wrenpp.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with wrenpp.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "module_and_name.hpp"
#include <string_view>

namespace wren {
	class VM;

	typedef std::string_view wren_string_t;
	typedef void(*finalizer_t)(void*);
	typedef void(*foreign_method_t)(VM&, ModuleAndName);

	struct foreign_class_t {
		foreign_method_t allocate;
		finalizer_t finalize;
	};
} //namespace wren
