/* Copyright 2020-2022, Michele Santullo
 * This file is part of wrenpp.
 *
 * Wrenpp is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Wrenpp is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with wrenpp.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "wrenpp/configuration.hpp"
#include <wren.hpp>

namespace wren {
	Configuration::Configuration() {
		WrenConfiguration conf;
		wrenInitConfiguration(&conf);

		m_initial_heap_size = conf.initialHeapSize;
		m_min_heap_size = conf.minHeapSize;
		m_heap_growth_percent = conf.heapGrowthPercent;
	}
} //namespace wren
